## qtcreator 12.0.1

=== debian/changelog ===
qtcreator (12.0.1-1deepin1) UNRELEASED; urgency=medium

  * Requires qt6-quick3d private headers on >= 6.6.1.

 -- Tianyu Chen <sweetyfish@deepin.org>  Wed, 27 Dec 2023 05:48:24 +0000

qtcreator (12.0.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Tweak the configuration for the CI on salsa so it can be actually run.

 -- Pino Toscano <pino@debian.org>  Sat, 16 Dec 2023 15:41:13 +0100

qtcreator (12.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Thu, 23 Nov 2023 22:17:43 +0100

qtcreator (11.0.3-1) experimental; urgency=medium

  * New upstream release.
  * Update the patches:
    - upstream_ClangTools-Add-support-for-yaml-cpp-0.8.patch: drop, backported
      from upsteam

 -- Pino Toscano <pino@debian.org>  Thu, 28 Sep 2023 13:04:08 +0200

qtcreator (11.0.2-1) experimental; urgency=medium

  * Team upload.
  * Upload to experimental, as QML Designer needs Qt 6.4.3, which is not present
    in Debian at the time of this writing.
  * New upstream release.
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update the build dependencies according to the upstream build system:
    - add xxd
    - add qt6-qmllint-plugins as workaround for a missing dependency in
      qt6-declarative-dev

 -- Pino Toscano <pino@debian.org>  Sun, 27 Aug 2023 22:30:32 +0200

=== debian/control ===
Source: qtcreator
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
Build-Depends: clang (>= 1:10~),
               clangd (>= 1:14~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               libclang-dev (>= 1:10~),
               libdw-dev,
               libqt6opengl6-dev (>= 6.2~),
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:10~),
               pkg-config,
               python3:any,
               qt6-5compat-dev (>= 6.2~),
               qt6-base-dev (>= 6.2.4+dfsg-3~),
               qt6-base-private-dev (>= 6.2.4+dfsg-3~),
               qt6-declarative-dev (>= 6.2~),
               qt6-declarative-private-dev (>= 6.2~),
               qt6-quick3d-dev (>= 6.2.4-2~),
               qt6-quick3d-dev (<< 6.6.1-1) | qt6-quick3d-private-dev (>= 6.6.1-1),
               qt6-quicktimeline-dev (>= 6.2~),
               qt6-serialport-dev (>= 6.2~),
               qt6-shadertools-dev (>= 6.2.4-2~),
               qt6-svg-dev (>= 6.2~),
               qt6-tools-dev (>= 6.2.4-2~),
               qt6-tools-private-dev (>= 6.2.4-2~),
               xxd,
# workaround missing dependency in qt6-declarative-dev
               qt6-qmllint-plugins,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git -b experimental
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator/-/tree/experimental

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:14~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-qmltooling-plugins,
            qt6-base-dev-tools,
            qtcreator-doc,
            qt6-declarative-dev-tools,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind,
          python3-pylsp,
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: qt6-image-formats-plugins,
         ${misc:Depends},
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.

=== debian/watch ===
version=4
opts="uversionmangle=s/-beta/~beta/;s/-rc/~rc/" \
https://download.qt.io/official_releases/qtcreator/([\d\.]*)/([\d\.]*)/qt-creator-opensource-src-([^-]*)\.tar\.xz

## qtcreator 13.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

## Add paths to check for cmake modules:
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(Utils)

env_with_default("QTC_BUILD_WITH_PCH" ENV_QTC_BUILD_WITH_PCH ON)
env_with_default("QTC_WITH_TESTS" ENV_QTC_WITH_TESTS OFF)
env_with_default("QTC_WITH_QMLDESIGNER" ENV_QTC_WITH_QMLDESIGNER ON)

option(BUILD_WITH_PCH "Build with precompiled headers" "${ENV_QTC_BUILD_WITH_PCH}")

include(FeatureSummary)
include(QtCreatorIDEBranding RESULT_VARIABLE IDE_BRANDING_FILE)
include(QtCreatorTranslations)
include(QtCreatorDocumentation)
include(QtCreatorAPI)

set(IDE_REVISION FALSE CACHE BOOL "Marks the presence of IDE revision string.")
set(IDE_REVISION_STR "" CACHE STRING "The IDE revision string.")
set(IDE_REVISION_URL "" CACHE STRING "The IDE revision Url string.")

mark_as_advanced(IDE_REVISION IDE_REVISION_STR IDE_REVISION_URL)

project(QtCreator VERSION ${IDE_VERSION})

# Force C++ standard, do not fall back, do not use compiler extensions
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

qtc_handle_compiler_cache_support()
qtc_handle_llvm_linker()

option(BUILD_LINK_WITH_QT "Link with Qt from the parent Qt Creator" OFF)
qtc_link_with_qt()

option(WITH_TESTS "Build Tests" ${ENV_QTC_WITH_TESTS})
add_feature_info("Build tests" ${WITH_TESTS} "")
option(WITH_DEBUG_CMAKE "Enabled CMake project debugging functionality" OFF)
option(SHOW_BUILD_DATE "Show build date in about dialog" OFF)
option(WITH_SANITIZE "Build with sanitizer enabled" OFF)
set(SANITIZE_FLAGS "" CACHE STRING "Sets flags for sanitizer compilation flags used in Debug builds")
add_feature_info("Build with sanitize" ${WITH_SANITIZE} "SANITIZE_FLAGS='${SANITIZE_FLAGS}'")


# merge binary directories of sub projects into top level
set(QTC_MERGE_BINARY_DIR ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Set up Qt stuff:
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if (WITH_TESTS)
  set(QT_TEST_COMPONENT Test)
  set(IMPLICIT_DEPENDS Qt::Test)
endif()

# suppress bogus warning
# warning C4573 requires the compiler to capture 'this' but the current default capture mode does not allow it
# when using QObject::connect in lambda without capturing 'this' - which would lead to warnings
# with other compilers
if(MSVC)
  add_compile_options(/wd4573)
endif()

find_package(Qt6
  ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Network PrintSupport Qml Sql Widgets Xml Core5Compat ${QT_TEST_COMPONENT}
  REQUIRED
)

if (Qt6_VERSION VERSION_GREATER_EQUAL 6.4.3)
    option(WITH_QMLDESIGNER "Build QmlDesigner" ${ENV_QTC_WITH_QMLDESIGNER})
else()
    option(WITH_QMLDESIGNER "Build QmlDesigner" OFF)
endif()
add_feature_info("Build QmlDesigner and related code (only if Qt is 6.4.3 or newer)" ${WITH_QMLDESIGNER} "")

# hack for Qbs which still supports Qt5 and Qt6
if (TARGET Qt6::Core5CompatPrivate)
    if (CMAKE_VERSION VERSION_LESS 3.18)
        set_property(TARGET Qt6::Core5CompatPrivate PROPERTY IMPORTED_GLOBAL TRUE)
    endif()
    add_library(Qt6Core5CompatPrivate ALIAS Qt6::Core5CompatPrivate)
endif()
if (TARGET Qt6::Core5Compat)
    if (CMAKE_VERSION VERSION_LESS 3.18)
        set_property(TARGET Qt6::Core5Compat PROPERTY IMPORTED_GLOBAL TRUE)
    endif()
    add_library(Qt6Core5Compat ALIAS Qt6::Core5Compat)
endif()

# Common intermediate directory for QML modules which are defined via qt_add_qml_module()
set(QT_QML_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/qml_modules")

# This includes the code that will enable higher compiler warnings level (/W3 for MSVC, -Wall -Wextra for GCC)
# This is controlled by QT_COMPILE_OPTIONS_DISABLE_WARNINGS target property.
include(QtCompilerFlags)

if (MSVC AND QT_FEATURE_static_runtime)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

find_package(Qt6 OPTIONAL_COMPONENTS Quick QuickWidgets Designer DesignerComponentsPrivate
                                     Help SerialPort Svg Tools LinguistTools QUIET)

find_package(Threads)
find_package(Clang QUIET)

# Crashpad
set(CRASHPAD_BACKEND_URL "" CACHE STRING "Crashpad backend URL")
set(BUILD_WITH_CRASHPAD OFF)
# Linux is not supported for now
# x86_64;arm64 is not supported for now
if(CRASHPAD_BACKEND_URL AND (WIN32 OR APPLE)) # Linux is not supported for now
  find_package(Crashpad QUIET)
  if(TARGET Crashpad::Crashpad)
    set(BUILD_WITH_CRASHPAD ON)
  endif()
endif()
add_feature_info("Build with Crashpad" ${BUILD_WITH_CRASHPAD} "")

function (set_if_target var target)
   if (TARGET "${target}")
     set(_result ON)
   else()
     set(_result OFF)
   endif()
   set(${var} "${_result}" PARENT_SCOPE)
endfunction()

set_if_target(_has_svg_target Qt::Svg)
option(ENABLE_SVG_SUPPORT "Enable SVG support" "${_has_svg_target}")

add_library(OptionalSvg INTERFACE)
if (TARGET Qt::Svg AND ENABLE_SVG_SUPPORT)
  target_link_libraries(OptionalSvg INTERFACE Qt::Svg)
else()
  target_compile_definitions(OptionalSvg INTERFACE QT_NO_SVG)
endif()
install(TARGETS OptionalSvg EXPORT QtCreator)

if (APPLE)
  find_library(FWCoreFoundation CoreFoundation)
  find_library(FWCoreServices CoreServices)
  find_library(FWFoundation Foundation)
  find_library(FWAppKit AppKit)
  find_library(FWIOKit IOKit)
  find_library(FWSecurity Security)
  find_library(FWSystemConfiguration SystemConfiguration)
  find_library(FWWebKit WebKit)
endif()

if (WITH_TESTS)
  enable_testing()
endif()

if (UNIX)
  add_subdirectory(bin)
endif()

add_subdirectory(src)
add_subdirectory(share)
add_subdirectory(dist)

if (WITH_TESTS)
  add_subdirectory(tests)
endif()

add_subdirectory(doc)

setup_dependencies_component()

feature_summary(INCLUDE_QUIET_PACKAGES WHAT
  PACKAGES_FOUND PACKAGES_NOT_FOUND
  ENABLED_FEATURES DISABLED_FEATURES
)

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR
    AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.GPL3-EXCEPT")
  # Only for opensource, non-super-repo builds
  add_subdirectory(packaging)
endif()

=== doc/CMakeLists.txt ===
# Generate documentation

option(BUILD_DEVELOPER_DOCS "Include developer documentation" OFF)
add_feature_info("Include developer documentation" BUILD_DEVELOPER_DOCS "")

function(_find_all_includes _ret_includes _ret_framework_paths)
  set(_all_includes "${PROJECT_SOURCE_DIR}/src/plugins;${PROJECT_SOURCE_DIR}/src/libs")
  foreach(_target ${__QTC_PLUGINS} ${__QTC_LIBRARIES})
    if (NOT TARGET ${_target})
      continue()
    endif()
    get_target_property(_includes ${_target} INCLUDE_DIRECTORIES)
    foreach(_include ${_includes})
      string(FIND "${_include}" "/src/plugins/" _in_plugins)
      string(FIND "${_include}" "/src/libs/" _in_libs)
      string(FIND "${_include}" "${CMAKE_BINARY_DIR}" _in_build)
      if(_in_plugins LESS 0 AND _in_libs LESS 0 AND _in_build LESS 0)
        list(APPEND _all_includes ${_include})
      endif()
    endforeach()
  endforeach()
  list(APPEND _all_includes ${CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES})
  list(REMOVE_DUPLICATES _all_includes)
  set("${_ret_includes}" "${_all_includes}" PARENT_SCOPE)

  # framework path
  if (APPLE)
    # version-less target Qt::Core is an interface library that links to QtX::Core
    get_target_property(_qt_core Qt::Core INTERFACE_LINK_LIBRARIES)
    get_target_property(_qt_target ${_qt_core} LOCATION) # <fw_path>/QtCore.framework/QtCore
    get_filename_component(_qt_loc "${_qt_target}" DIRECTORY)
    set("${_ret_framework_paths}" "${_qt_loc}/.." PARENT_SCOPE)
  endif()
endfunction()

function(_add_doc _doc_file _dev_doc_file)
  set(GENERATED_ATTRIBUTIONS_DIR ${CMAKE_CURRENT_BINARY_DIR}/generated_attributions)
  add_qtc_documentation(${_doc_file}
    ENVIRONMENT_EXPORTS GENERATED_ATTRIBUTIONS_DIR
  )
  add_qtc_doc_attribution(doc_attributions
    "${CMAKE_CURRENT_SOURCE_DIR}/../qt_attributions.json"
    "${GENERATED_ATTRIBUTIONS_DIR}/creator-attributions.qdoc"
    ${_doc_file}
  )
  set(litehtml_attributions "${CMAKE_CURRENT_SOURCE_DIR}/../src/libs/qlitehtml/src/3rdparty/qt_attribution.json")
  if(EXISTS "${litehtml_attributions}")
    add_qtc_doc_attribution(doc_attributions_litehtml
      "${litehtml_attributions}"
      "${GENERATED_ATTRIBUTIONS_DIR}/creator-attributions-litehtml.qdoc"
      ${_doc_file}
    )
  endif()
  if (BUILD_DEVELOPER_DOCS)
    _find_all_includes(_all_includes _framework_paths)
    add_qtc_documentation(${_dev_doc_file}
      INCLUDE_DIRECTORIES ${_all_includes}
      FRAMEWORK_PATHS ${_framework_paths}
    )
  endif()
endfunction()

if (WITH_DOCS)
  _add_doc(${IDE_DOC_FILE} "qtcreatordev/qtcreator-dev.qdocconf")
endif()
if(WITH_ONLINE_DOCS)
  _add_doc(${IDE_DOC_FILE_ONLINE} "qtcreatordev/qtcreator-dev-online.qdocconf")
endif()

install(DIRECTORY config
  DESTINATION ${IDE_HEADER_INSTALL_PATH}/doc
  COMPONENT Devel
  EXCLUDE_FROM_ALL
)

=== src/CMakeLists.txt ===
add_library(app_version INTERFACE)
target_include_directories(app_version
  INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  INTERFACE $<INSTALL_INTERFACE:${IDE_HEADER_INSTALL_PATH}/src>)
install(TARGETS app_version EXPORT QtCreator)

add_subdirectory(libs)
add_subdirectory(share)
add_subdirectory(shared)
add_subdirectory(plugins)
add_subdirectory(app)
add_subdirectory(tools)

install(
  FILES
    ${PROJECT_SOURCE_DIR}/HACKING
    ${PROJECT_SOURCE_DIR}/LICENSE.GPL3-EXCEPT
    ${PROJECT_SOURCE_DIR}/README.md
  DESTINATION ${IDE_DATA_PATH}
  COMPONENT Devel EXCLUDE_FROM_ALL
)

install(
  DIRECTORY
    ${PROJECT_SOURCE_DIR}/scripts
  DESTINATION ${IDE_DATA_PATH}
  COMPONENT Devel EXCLUDE_FROM_ALL
  USE_SOURCE_PERMISSIONS
)

install(EXPORT QtCreator
  DESTINATION ${IDE_CMAKE_INSTALL_PATH}/QtCreator
  COMPONENT Devel EXCLUDE_FROM_ALL
  NAMESPACE QtCreator::
  FILE QtCreatorTargets.cmake
)

file(WRITE ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake "
\# force plugins to same path naming conventions as Qt Creator
\# otherwise plugins will not be found
if(UNIX AND NOT APPLE)
  include(GNUInstallDirs)
  set(CMAKE_INSTALL_BINDIR ${CMAKE_INSTALL_BINDIR})
  set(CMAKE_INSTALL_LIBDIR ${CMAKE_INSTALL_LIBDIR})
  set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBEXECDIR})
  set(CMAKE_INSTALL_DATAROOTDIR ${CMAKE_INSTALL_DATAROOTDIR})
endif()

include(CMakeFindDependencyMacro)
find_dependency(Qt6 ${IDE_QT_VERSION_MIN}
  COMPONENTS Concurrent Core Gui Widgets Core5Compat Network PrintSupport Qml Sql REQUIRED
)
find_dependency(Qt6 COMPONENTS Quick QuickWidgets QUIET)

if (NOT IDE_VERSION)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorIDEBranding.cmake)
endif()

if (NOT DEFINED add_qtc_plugin)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorAPI.cmake)
endif()

if (NOT DEFINED add_translation_targets)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorTranslations.cmake)
endif()

if (NOT DEFINED add_qtc_documentation)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorDocumentation.cmake)
endif()

if (NOT TARGET QtCreator::Core)
  include(\${CMAKE_CURRENT_LIST_DIR}/QtCreatorTargets.cmake)
endif()
")

# Local build export
export(EXPORT QtCreator
  NAMESPACE QtCreator::
  FILE ${CMAKE_BINARY_DIR}/cmake/QtCreatorTargets.cmake)

file(COPY
  ${IDE_BRANDING_FILE}
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorTranslations.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorDocumentation.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPIInternal.cmake
  ${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in
  ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.cmake
  ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.Info.plist.in
  DESTINATION ${CMAKE_BINARY_DIR}/cmake
)

# Devel package install
install(
  FILES
    ${IDE_BRANDING_FILE}
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorTranslations.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorDocumentation.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPI.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtCreatorAPIInternal.cmake
    ${PROJECT_SOURCE_DIR}/cmake/Config.cmake.in
    ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.cmake
    ${PROJECT_SOURCE_DIR}/cmake/QtcSeparateDebugInfo.Info.plist.in
    ${CMAKE_BINARY_DIR}/cmake/QtCreatorConfig.cmake
  DESTINATION ${IDE_CMAKE_INSTALL_PATH}/QtCreator
  COMPONENT Devel EXCLUDE_FROM_ALL
)

=== share/qtcreator/CMakeLists.txt ===
set(resource_directories
  android
  cplusplus
  glsl
  indexer_preincludes
  modeleditor
  qmldesigner
  qmlicons
  qml-type-descriptions
  schemes
  snippets
  styles
  templates
  themes
)

set(resource_files
  debugger/.pylintrc
  debugger/boosttypes.py
  debugger/cdbbridge.py
  debugger/creatortypes.py
  debugger/dumper.py
  debugger/gdbbridge.py
  debugger/gdbtracepoint.py
  debugger/LICENSE.GPL3-EXCEPT
  debugger/lldbbridge.py
  debugger/misctypes.py
  debugger/opencvtypes.py
  debugger/pdbbridge.py
  debugger/personaltypes.py
  debugger/qttypes.py
  debugger/README.txt
  debugger/setup.cfg
  debugger/android_stdtypes.py
  debugger/libcpp_stdtypes.py
  debugger/stdtypes.py
  debugger/utils.py
  debugger/loadorder.txt
)

# copy resource directories during build
qtc_copy_to_builddir(copy_share_to_builddir
  DIRECTORIES ${resource_directories}
  DESTINATION "${IDE_DATA_PATH}"
  CREATE_SUBDIRS
)

# copy resource files during build
qtc_copy_to_builddir(copy_share_files_to_builddir
  FILES ${resource_files}
  DESTINATION ${IDE_DATA_PATH}
)

# create install rule for resource directories
install(
  DIRECTORY ${resource_directories}
  DESTINATION "${IDE_DATA_PATH}"
  USE_SOURCE_PERMISSIONS
)

# create install rule for resource files
foreach(file ${resource_files})
  get_filename_component(path "${file}" DIRECTORY)
  install(
    FILES "${file}"
    DESTINATION "${IDE_DATA_PATH}/${path}"
  )
endforeach()


add_subdirectory(translations)

=== src/libs/CMakeLists.txt ===
add_subdirectory(3rdparty)

add_subdirectory(nanotrace)
add_subdirectory(advanceddockingsystem)
add_subdirectory(aggregation)
add_subdirectory(cplusplus)
add_subdirectory(extensionsystem)
add_subdirectory(glsl)
add_subdirectory(languageserverprotocol)
add_subdirectory(languageutils)
add_subdirectory(modelinglib)
add_subdirectory(qmldebug)
add_subdirectory(qmleditorwidgets)
add_subdirectory(qmljs)
add_subdirectory(qtcreatorcdbext)
add_subdirectory(utils)
add_subdirectory(solutions)
add_subdirectory(tracing)

if (WITH_QMLDESIGNER)
  add_subdirectory(sqlite)
  add_subdirectory(qmlpuppetcommunication)
endif()

if (WITH_TESTS)
 add_subdirectory(googletest)
endif()

if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/qlitehtml/src/CMakeLists.txt)
  option(BUILD_LIBRARY_QLITEHTML "Build library qlitehtml." ${BUILD_LIBRARIES_BY_DEFAULT})
  set(QLITEHTML_VERSION_COMPAT ${IDE_VERSION_COMPAT} CACHE STRING "")
  if(BUILD_LIBRARY_QLITEHTML)
    set(QLITEHTML_LIBRARY_ARCHIVE_PATH ${IDE_LIBRARY_ARCHIVE_PATH})
    set(QLITEHTML_EXPORT QtCreator)
    set(QLITEHTML_DEVEL_COMPONENT Devel)
    set(QLITEHTML_DEVEL_EXCLUDE_FROM_ALL ON)
    set(QLITEHTML_HEADER_PATH "${IDE_HEADER_INSTALL_PATH}/src/lib/qlitehtml")
    if (QTC_STATIC_BUILD)
      set(QLITEHTML_LIBRARY_TYPE STATIC)
    else()
      set(QLITEHTML_BIN_PATH ${IDE_BIN_PATH})
      set(QLITEHTML_LIBRARY_PATH ${IDE_LIBRARY_PATH})
    endif()
    set(QT_VERSION_MAJOR ${Qt6_VERSION_MAJOR})
    option(BUILD_TESTING "Build litehtml tests" OFF) # otherwise litehtml downloads googletest
    add_subdirectory(qlitehtml/src)
  endif()
  if(TARGET qlitehtml)
    target_compile_definitions(qlitehtml PRIVATE ${DEFAULT_DEFINES}) # for precompiled headers
    enable_pch(qlitehtml)
    #doesn't work: TARGET 'qlitehtml' was not created in this directory.
    #qtc_enable_separate_debug_info(qlitehtml "${IDE_LIBRARY_PATH}")
    qtc_output_binary_dir(_output_binary_dir)
    set_target_properties(qlitehtml PROPERTIES
      BUILD_RPATH "${_LIB_RPATH};${CMAKE_BUILD_RPATH}"
      INSTALL_RPATH "${_LIB_RPATH};${CMAKE_INSTALL_RPATH}"
      RUNTIME_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_BIN_PATH}"
      LIBRARY_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_LIBRARY_PATH}"
      ARCHIVE_OUTPUT_DIRECTORY "${_output_binary_dir}/${IDE_LIBRARY_ARCHIVE_PATH}"
    )
  endif()
endif()

=== tests/manual/CMakeLists.txt ===
# add_subdirectory(autotoolsprojectmanager)
# add_subdirectory(clang-format-for-qtc)
# add_subdirectory(cplusplus-tools)
# add_subdirectory(cppquickfix)
add_subdirectory(debugger)
add_subdirectory(deviceshell)
# add_subdirectory(distribution)
# add_subdirectory(dockwidgets)
add_subdirectory(fakevim)
# add_subdirectory(features)
# add_subdirectory(filesystemview)
# add_subdirectory(genericproject)
add_subdirectory(pluginview)
add_subdirectory(proparser)
add_subdirectory(terminal)
# add_subdirectory(qml)
# add_subdirectory(qt4projectmanager)
# add_subdirectory(search)
add_subdirectory(shootout)
add_subdirectory(spinner)
add_subdirectory(subdirfilecontainer)
add_subdirectory(tasking)
add_subdirectory(widgets)

=== dist/branding/qtdesignstudio/CMakeLists.txt ===
install(DIRECTORY QtProject DESTINATION "${IDE_DATA_PATH}")

=== src/libs/3rdparty/CMakeLists.txt ===
add_subdirectory(cplusplus)
add_subdirectory(syntax-highlighting)
add_subdirectory(libvterm)
add_subdirectory(libptyqt)
add_subdirectory(qrcodegen)
add_subdirectory(qtkeychain)

if(WIN32)
    add_subdirectory(winpty)
endif()

=== src/libs/modelinglib/CMakeLists.txt ===
add_qtc_library(Modeling
  DEPENDS Qt::Widgets Utils
  PUBLIC_DEPENDS OptionalSvg
  INCLUDES qtserialization/inc
  PUBLIC_INCLUDES
    "${CMAKE_CURRENT_LIST_DIR}"
  SOURCES
    modelinglibtr.h
    qmt/config/configcontroller.cpp qmt/config/configcontroller.h
    qmt/config/sourcepos.cpp qmt/config/sourcepos.h
    qmt/config/stereotypedefinitionparser.cpp qmt/config/stereotypedefinitionparser.h
    qmt/config/stringtextsource.cpp qmt/config/stringtextsource.h
    qmt/config/textscanner.cpp qmt/config/textscanner.h
    qmt/config/textsource.h
    qmt/config/token.cpp qmt/config/token.h
    qmt/controller/container.h
    qmt/controller/namecontroller.cpp qmt/controller/namecontroller.h
    qmt/controller/references.h
    qmt/controller/selection.cpp qmt/controller/selection.h
    qmt/controller/undocommand.cpp qmt/controller/undocommand.h
    qmt/controller/undocontroller.cpp qmt/controller/undocontroller.h
    qmt/diagram_controller/dclonevisitor.cpp qmt/diagram_controller/dclonevisitor.h
    qmt/diagram_controller/dcontainer.h
    qmt/diagram_controller/dfactory.cpp qmt/diagram_controller/dfactory.h
    qmt/diagram_controller/dflatassignmentvisitor.cpp qmt/diagram_controller/dflatassignmentvisitor.h
    qmt/diagram_controller/diagramcontroller.cpp qmt/diagram_controller/diagramcontroller.h
    qmt/diagram_controller/dreferences.h
    qmt/diagram_controller/dselection.h
    qmt/diagram_controller/dupdatevisitor.cpp qmt/diagram_controller/dupdatevisitor.h
    qmt/diagram_controller/dvoidvisitor.cpp qmt/diagram_controller/dvoidvisitor.h
    qmt/diagram/dannotation.cpp qmt/diagram/dannotation.h
    qmt/diagram/dassociation.cpp qmt/diagram/dassociation.h
    qmt/diagram/dboundary.cpp qmt/diagram/dboundary.h
    qmt/diagram/dclass.cpp qmt/diagram/dclass.h
    qmt/diagram/dcomponent.cpp qmt/diagram/dcomponent.h
    qmt/diagram/dconnection.cpp qmt/diagram/dconnection.h
    qmt/diagram/dconstvisitor.h
    qmt/diagram/ddependency.cpp qmt/diagram/ddependency.h
    qmt/diagram/ddiagram.cpp qmt/diagram/ddiagram.h
    qmt/diagram/delement.cpp qmt/diagram/delement.h
    qmt/diagram/dinheritance.cpp qmt/diagram/dinheritance.h
    qmt/diagram/ditem.cpp qmt/diagram/ditem.h
    qmt/diagram/dobject.cpp qmt/diagram/dobject.h
    qmt/diagram/dpackage.cpp qmt/diagram/dpackage.h
    qmt/diagram/drelation.cpp qmt/diagram/drelation.h
    qmt/diagram/dswimlane.cpp qmt/diagram/dswimlane.h
    qmt/diagram/dvisitor.h
    qmt/diagram_scene/capabilities/alignable.h
    qmt/diagram_scene/capabilities/editable.h
    qmt/diagram_scene/capabilities/intersectionable.h
    qmt/diagram_scene/capabilities/latchable.h
    qmt/diagram_scene/capabilities/moveable.h
    qmt/diagram_scene/capabilities/relationable.h
    qmt/diagram_scene/capabilities/resizable.h
    qmt/diagram_scene/capabilities/selectable.h
    qmt/diagram_scene/capabilities/windable.h
    qmt/diagram_scene/diagramgraphicsscene.cpp qmt/diagram_scene/diagramgraphicsscene.h
    qmt/diagram_scene/diagramsceneconstants.h
    qmt/diagram_scene/diagramscenemodel.cpp qmt/diagram_scene/diagramscenemodel.h
    qmt/diagram_scene/diagramscenemodelitemvisitors.cpp qmt/diagram_scene/diagramscenemodelitemvisitors.h
    qmt/diagram_scene/items/annotationitem.cpp qmt/diagram_scene/items/annotationitem.h
    qmt/diagram_scene/items/associationitem.cpp qmt/diagram_scene/items/associationitem.h
    qmt/diagram_scene/items/boundaryitem.cpp qmt/diagram_scene/items/boundaryitem.h
    qmt/diagram_scene/items/classitem.cpp qmt/diagram_scene/items/classitem.h
    qmt/diagram_scene/items/componentitem.cpp qmt/diagram_scene/items/componentitem.h
    qmt/diagram_scene/items/connectionitem.cpp qmt/diagram_scene/items/connectionitem.h
    qmt/diagram_scene/items/diagramitem.cpp qmt/diagram_scene/items/diagramitem.h
    qmt/diagram_scene/items/itemitem.cpp qmt/diagram_scene/items/itemitem.h
    qmt/diagram_scene/items/objectitem.cpp qmt/diagram_scene/items/objectitem.h
    qmt/diagram_scene/items/packageitem.cpp qmt/diagram_scene/items/packageitem.h
    qmt/diagram_scene/items/relationitem.cpp qmt/diagram_scene/items/relationitem.h
    qmt/diagram_scene/items/stereotypedisplayvisitor.cpp qmt/diagram_scene/items/stereotypedisplayvisitor.h
    qmt/diagram_scene/items/swimlaneitem.cpp qmt/diagram_scene/items/swimlaneitem.h
    qmt/diagram_scene/latchcontroller.cpp qmt/diagram_scene/latchcontroller.h
    qmt/diagram_scene/parts/alignbuttonsitem.cpp qmt/diagram_scene/parts/alignbuttonsitem.h
    qmt/diagram_scene/parts/alignlineitem.cpp qmt/diagram_scene/parts/alignlineitem.h
    qmt/diagram_scene/parts/arrowitem.cpp qmt/diagram_scene/parts/arrowitem.h
    qmt/diagram_scene/parts/contextlabelitem.cpp qmt/diagram_scene/parts/contextlabelitem.h
    qmt/diagram_scene/parts/customiconitem.cpp qmt/diagram_scene/parts/customiconitem.h
    qmt/diagram_scene/parts/editabletextitem.cpp qmt/diagram_scene/parts/editabletextitem.h
    qmt/diagram_scene/parts/pathselectionitem.cpp qmt/diagram_scene/parts/pathselectionitem.h
    qmt/diagram_scene/parts/rectangularselectionitem.cpp qmt/diagram_scene/parts/rectangularselectionitem.h
    qmt/diagram_scene/parts/relationstarter.cpp qmt/diagram_scene/parts/relationstarter.h
    qmt/diagram_scene/parts/stereotypesitem.cpp qmt/diagram_scene/parts/stereotypesitem.h
    qmt/diagram_scene/parts/templateparameterbox.cpp qmt/diagram_scene/parts/templateparameterbox.h
    qmt/diagram_ui/diagram_mime_types.h
    qmt/diagram_ui/diagramsmanager.cpp qmt/diagram_ui/diagramsmanager.h
    qmt/diagram_ui/diagramsviewinterface.h
    qmt/diagram_ui/sceneinspector.cpp qmt/diagram_ui/sceneinspector.h
    qmt/diagram_widgets_ui/diagramsview.cpp qmt/diagram_widgets_ui/diagramsview.h
    qmt/diagram_widgets_ui/diagramview.cpp qmt/diagram_widgets_ui/diagramview.h
    qmt/diagram_widgets_ui/stackeddiagramsview.cpp qmt/diagram_widgets_ui/stackeddiagramsview.h
    qmt/document_controller/documentcontroller.cpp qmt/document_controller/documentcontroller.h
    qmt/infrastructure/contextmenuaction.cpp qmt/infrastructure/contextmenuaction.h
    qmt/infrastructure/exceptions.cpp qmt/infrastructure/exceptions.h
    qmt/infrastructure/geometryutilities.cpp qmt/infrastructure/geometryutilities.h
    qmt/infrastructure/handle.h
    qmt/infrastructure/handles.h
    qmt/infrastructure/ioexceptions.cpp qmt/infrastructure/ioexceptions.h
    qmt/infrastructure/qcompressedfile.cpp qmt/infrastructure/qcompressedfile.h
    qmt/infrastructure/qmtassert.h
    qmt/infrastructure/qmt_global.h
    qmt/infrastructure/uid.h
    qmt/model_controller/mchildrenvisitor.cpp qmt/model_controller/mchildrenvisitor.h
    qmt/model_controller/mclonevisitor.cpp qmt/model_controller/mclonevisitor.h
    qmt/model_controller/mcontainer.h
    qmt/model_controller/mflatassignmentvisitor.cpp qmt/model_controller/mflatassignmentvisitor.h
    qmt/model_controller/modelcontroller.cpp qmt/model_controller/modelcontroller.h
    qmt/model_controller/mreferences.h
    qmt/model_controller/mselection.h
    qmt/model_controller/mvoidvisitor.cpp qmt/model_controller/mvoidvisitor.h
    qmt/model/massociation.cpp qmt/model/massociation.h
    qmt/model/mcanvasdiagram.cpp qmt/model/mcanvasdiagram.h
    qmt/model/mclass.cpp qmt/model/mclass.h
    qmt/model/mclassmember.cpp qmt/model/mclassmember.h
    qmt/model/mcomponent.cpp qmt/model/mcomponent.h
    qmt/model/mconnection.cpp qmt/model/mconnection.h
    qmt/model/mconstvisitor.h
    qmt/model/mdependency.cpp qmt/model/mdependency.h
    qmt/model/mdiagram.cpp qmt/model/mdiagram.h
    qmt/model/melement.cpp qmt/model/melement.h
    qmt/model/minheritance.cpp qmt/model/minheritance.h
    qmt/model/mitem.cpp qmt/model/mitem.h
    qmt/model/mobject.cpp qmt/model/mobject.h
    qmt/model/mpackage.cpp qmt/model/mpackage.h
    qmt/model/mrelation.cpp qmt/model/mrelation.h
    qmt/model/msourceexpansion.cpp qmt/model/msourceexpansion.h
    qmt/model/mvisitor.h
    qmt/model_ui/modeltreeviewinterface.h
    qmt/model_ui/sortedtreemodel.cpp qmt/model_ui/sortedtreemodel.h
    qmt/model_ui/stereotypescontroller.cpp qmt/model_ui/stereotypescontroller.h
    qmt/model_ui/treemodel.cpp qmt/model_ui/treemodel.h
    qmt/model_ui/treemodelmanager.cpp qmt/model_ui/treemodelmanager.h
    qmt/model_widgets_ui/classmembersedit.cpp qmt/model_widgets_ui/classmembersedit.h
    qmt/model_widgets_ui/modeltreeview.cpp qmt/model_widgets_ui/modeltreeview.h
    qmt/model_widgets_ui/palettebox.cpp qmt/model_widgets_ui/palettebox.h
    qmt/model_widgets_ui/propertiesview.cpp qmt/model_widgets_ui/propertiesview.h
    qmt/model_widgets_ui/propertiesviewmview.cpp qmt/model_widgets_ui/propertiesviewmview.h
    qmt/project_controller/projectcontroller.cpp qmt/project_controller/projectcontroller.h
    qmt/project/project.cpp qmt/project/project.h
    qmt/resources/resources_modelinglib.qrc
    qmt/serializer/diagramserializer.cpp qmt/serializer/diagramserializer.h
    qmt/serializer/infrastructureserializer.cpp qmt/serializer/infrastructureserializer.h
    qmt/serializer/modelserializer.cpp qmt/serializer/modelserializer.h
    qmt/serializer/projectserializer.cpp qmt/serializer/projectserializer.h
    qmt/stereotype/customrelation.cpp qmt/stereotype/customrelation.h
    qmt/stereotype/iconshape.cpp qmt/stereotype/iconshape.h
    qmt/stereotype/shape.h
    qmt/stereotype/shapepaintvisitor.cpp qmt/stereotype/shapepaintvisitor.h
    qmt/stereotype/shapes.cpp qmt/stereotype/shapes.h
    qmt/stereotype/shapevalue.cpp qmt/stereotype/shapevalue.h
    qmt/stereotype/shapevisitor.h
    qmt/stereotype/stereotypecontroller.cpp qmt/stereotype/stereotypecontroller.h
    qmt/stereotype/stereotypeicon.cpp qmt/stereotype/stereotypeicon.h
    qmt/stereotype/toolbar.cpp qmt/stereotype/toolbar.h
    qmt/style/defaultstyle.cpp
    qmt/style/defaultstyleengine.cpp qmt/style/defaultstyleengine.h
    qmt/style/defaultstyle.h
    qmt/style/objectvisuals.cpp qmt/style/objectvisuals.h
    qmt/style/relationstarterstyle.cpp qmt/style/relationstarterstyle.h
    qmt/style/stylecontroller.cpp qmt/style/stylecontroller.h
    qmt/style/style.cpp
    qmt/style/styledobject.cpp qmt/style/styledobject.h
    qmt/style/styledrelation.cpp qmt/style/styledrelation.h
    qmt/style/styleengine.h
    qmt/style/style.h
    qmt/tasks/alignonrastervisitor.cpp qmt/tasks/alignonrastervisitor.h
    qmt/tasks/diagramscenecontroller.cpp qmt/tasks/diagramscenecontroller.h
    qmt/tasks/finddiagramvisitor.cpp qmt/tasks/finddiagramvisitor.h
    qmt/tasks/findrootdiagramvisitor.cpp qmt/tasks/findrootdiagramvisitor.h
    qmt/tasks/ielementtasks.h
    qmt/tasks/isceneinspector.h
    qmt/tasks/voidelementtasks.cpp qmt/tasks/voidelementtasks.h
    qstringparser/qstringparser.cpp qstringparser/qstringparser.h
    qtserialization/inc/qark/access.h
    qtserialization/inc/qark/archivebasics.h
    qtserialization/inc/qark/attribute.h
    qtserialization/inc/qark/baseclass.h
    qtserialization/inc/qark/flag.h
    qtserialization/inc/qark/friend_access.h
    qtserialization/inc/qark/impl/loadingrefmap.h
    qtserialization/inc/qark/impl/objectid.h
    qtserialization/inc/qark/impl/savingrefmap.h
    qtserialization/inc/qark/parameters.h
    qtserialization/inc/qark/qxmlinarchive.h
    qtserialization/inc/qark/qxmloutarchive.h
    qtserialization/inc/qark/reference.h
    qtserialization/inc/qark/serialize_basic.h
    qtserialization/inc/qark/serialize_container.h
    qtserialization/inc/qark/serialize_enum.h
    qtserialization/inc/qark/serialize.h
    qtserialization/inc/qark/serialize_pointer.h
    qtserialization/inc/qark/tag.h
    qtserialization/inc/qark/typeregistry.h
    qtserialization/src/flag.cpp
    qtserialization/src/savingrefmap.cpp
)

=== src/libs/qmldebug/CMakeLists.txt ===
add_qtc_library(QmlDebug
  DEPENDS Qt::Network Utils
  SOURCES
    baseenginedebugclient.cpp baseenginedebugclient.h
    basetoolsclient.cpp basetoolsclient.h
    qdebugmessageclient.cpp qdebugmessageclient.h
    qmldebug_global.h
    qmldebugtr.h
    qmldebugclient.cpp qmldebugclient.h
    qmldebugcommandlinearguments.h
    qmldebugconnection.cpp qmldebugconnection.h
    qmldebugconnectionmanager.cpp qmldebugconnectionmanager.h
    qmldebugconstants.h
    qmlenginecontrolclient.cpp qmlenginecontrolclient.h
    qmlenginedebugclient.h
    qmloutputparser.cpp qmloutputparser.h
    qmltoolsclient.cpp qmltoolsclient.h
    qpacketprotocol.cpp qpacketprotocol.h
)

=== src/plugins/android/CMakeLists.txt ===
add_qtc_plugin(Android
  DEPENDS QmlDebug Qt::Xml LanguageServerProtocol
  PLUGIN_DEPENDS Core Debugger ProjectExplorer QtSupport LanguageClient
  SOURCES
    android.qrc
    androidtr.h
    androidavdmanager.cpp androidavdmanager.h
    androidbuildapkstep.cpp androidbuildapkstep.h
    androidconfigurations.cpp androidconfigurations.h
    androidconstants.h
    androidcreatekeystorecertificate.cpp androidcreatekeystorecertificate.h
    androiddebugsupport.cpp androiddebugsupport.h
    androiddeployqtstep.cpp androiddeployqtstep.h
    androiddevice.cpp androiddevice.h
    androiddeviceinfo.cpp androiddeviceinfo.h
    androidextralibrarylistmodel.cpp androidextralibrarylistmodel.h
    androidglobal.h
    androidmanager.cpp androidmanager.h
    androidmanifestdocument.cpp androidmanifestdocument.h
    androidmanifesteditor.cpp androidmanifesteditor.h
    androidmanifesteditorfactory.cpp androidmanifesteditorfactory.h
    androidmanifesteditorwidget.cpp androidmanifesteditorwidget.h
    androidmanifesteditoriconwidget.cpp androidmanifesteditoriconwidget.h
    androidmanifesteditoriconcontainerwidget.cpp androidmanifesteditoriconcontainerwidget.h
    androidpackageinstallationstep.cpp androidpackageinstallationstep.h
    androidplugin.cpp
    androidpotentialkit.cpp androidpotentialkit.h
    androidqmlpreviewworker.cpp androidqmlpreviewworker.h
    androidqmltoolingsupport.cpp androidqmltoolingsupport.h
    androidqtversion.cpp androidqtversion.h
    androidrunconfiguration.cpp androidrunconfiguration.h
    androidruncontrol.cpp androidruncontrol.h
    androidrunner.cpp androidrunner.h
    androidrunnerworker.cpp androidrunnerworker.h
    androidsdkdownloader.cpp androidsdkdownloader.h
    androidsdkmanager.cpp androidsdkmanager.h
    androidsdkmanagerwidget.cpp androidsdkmanagerwidget.h
    androidsdkmodel.cpp androidsdkmodel.h
    androidsdkpackage.cpp androidsdkpackage.h
    androidsettingswidget.cpp androidsettingswidget.h
    androidsignaloperation.cpp androidsignaloperation.h
    androidtoolchain.cpp androidtoolchain.h
    avddialog.cpp avddialog.h
    avdmanageroutputparser.cpp avdmanageroutputparser.h
    certificatesmodel.cpp certificatesmodel.h
    createandroidmanifestwizard.cpp createandroidmanifestwizard.h
    javaeditor.cpp javaeditor.h
    javaindenter.cpp javaindenter.h
    javalanguageserver.cpp javalanguageserver.h
    javaparser.cpp javaparser.h
    splashscreencontainerwidget.cpp splashscreencontainerwidget.h
    splashscreenwidget.cpp splashscreenwidget.h
    sdkmanageroutputparser.cpp sdkmanageroutputparser.h
)

extend_qtc_plugin(Android
  CONDITION WITH_TESTS
  SOURCES
    androidsdkmanager_test.cpp androidsdkmanager_test.h
    sdkmanageroutputparser_test.cpp sdkmanageroutputparser_test.h
    android_tst.qrc
)

=== src/plugins/autotoolsprojectmanager/CMakeLists.txt ===
add_qtc_plugin(AutotoolsProjectManager
  PLUGIN_CLASS AutotoolsProjectPlugin
  PLUGIN_DEPENDS Core ProjectExplorer QtSupport
  SOURCES
    autogenstep.cpp autogenstep.h
    autoreconfstep.cpp autoreconfstep.h
    autotoolsbuildconfiguration.cpp autotoolsbuildconfiguration.h
    autotoolsbuildsystem.cpp autotoolsbuildsystem.h
    autotoolsprojectconstants.h
    autotoolsprojectmanagertr.h
    autotoolsprojectplugin.cpp
    configurestep.cpp configurestep.h
    makefileparser.cpp makefileparser.h
    makefileparserthread.cpp makefileparserthread.h
    makestep.cpp makestep.h
)

=== debian/changelog ===
qtcreator (13.0.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump clang/llvm development to 14

 -- Pino Toscano <pino@debian.org>  Fri, 05 Apr 2024 07:35:07 +0200

qtcreator (12.0.2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Sat, 10 Feb 2024 08:37:07 +0100

=== debian/control ===
--- 
+++ 
@@ -4,16 +4,16 @@
 Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Adam Majer <adamm@zombino.com>,
            Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
-Build-Depends: clang (>= 1:10~),
+Build-Depends: clang (>= 1:14~),
                clangd (>= 1:14~),
                cmake (>= 3.16~),
                debhelper-compat (= 13),
-               libclang-dev (>= 1:10~),
+               libclang-dev (>= 1:14~),
                libdw-dev,
                libqt6opengl6-dev (>= 6.2~),
                libyaml-cpp-dev (>= 0.5~),
                libzstd-dev,
-               llvm-dev (>= 1:10~),
+               llvm-dev (>= 1:14~),
                pkg-config,
                python3:any,
                qt6-5compat-dev (>= 6.2~),
@@ -22,7 +22,6 @@
                qt6-declarative-dev (>= 6.2~),
                qt6-declarative-private-dev (>= 6.2~),
                qt6-quick3d-dev (>= 6.2.4-2~),
-               qt6-quick3d-dev (<< 6.6.1-1) | qt6-quick3d-private-dev (>= 6.6.1-1),
                qt6-quicktimeline-dev (>= 6.2~),
                qt6-serialport-dev (>= 6.2~),
                qt6-shadertools-dev (>= 6.2.4-2~),

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

# Do not build the HelloWorld plugin, as it is not needed
export QTC_BUILD_PLUGIN_HELLOWORLD=FALSE

# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')

# the dwz processing for all the libraries and plugins can take a lot of memory,
# which may be not enough on some architectures (typically 32bit), resulting in
# dwz failing with "Could not allocate memory: Cannot allocate memory" errors;
# hence, on architectures where we see this result, try to use a more memory
# friendly processing for a lower number of DIEs (dwz default is 10M)
archs_with_dwz_low_mem = armel armhf
dwz_low_mem = 3000000

archs_using_clang = mips64el
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_using_clang)))
export CC=clang
export CXX=clang++
export DEB_CFLAGS_MAINT_APPEND := -gdwarf-4
export DEB_CXXFLAGS_MAINT_APPEND := -gdwarf-4
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
EXTRA_CMAKE_ARGS += -DBUILD_WITH_PCH=OFF
endif

%:
	dh $@ --builddirectory=builddir

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_DEVELOPER_DOCS=ON \
		-DBUILD_QBS=OFF \
		-DWITH_TESTS=OFF \
		-DBUILD_TESTING=OFF \
		-DCLANGTOOLING_LINK_CLANG_DYLIB=ON \
		-DWITH_DOCS=$(if $(filter qtcreator-doc, $(shell dh_listpackages)),ON,OFF) \
		$(EXTRA_CMAKE_ARGS)

execute_after_dh_auto_build-indep:
	dh_auto_build -- docs

execute_after_dh_auto_install:
ifneq (,$(filter qtcreator-doc, $(shell dh_listpackages)))
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component qch_docs
	DESTDIR=$(CURDIR)/debian/tmp cmake --install $(CURDIR)/builddir --component html_docs
endif

	# Not needed
	rm debian/tmp/usr/bin/qtcreator.sh

	# License files of the embedded copy of KSyntaxHighlighting
	rm -rf debian/tmp/usr/share/qtcreator/generic-highlighter/syntax/licenses/

	# Remove extra exec permissions
	find debian/tmp -name qmldir -type f -perm /111 -exec chmod -v -x {} \;

execute_after_dh_install:
	# Copied in qtcreator-doc already
	rm -rf debian/qtcreator-data/usr/share/qtcreator/doc/

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/$(DEB_HOST_MULTIARCH)/qtcreator/

override_dh_shlibdeps:
	echo 'libQt6DesignerComponents 6 libqt6designercomponents6 (>= $(call upstream_version_of_pkg,libqt6designercomponents6)~)' > debian/shlibs.local
	dh_shlibdeps -l$(CURDIR)/debian/qtcreator/usr/lib/$(DEB_HOST_MULTIARCH)/qtcreator
	rm debian/shlibs.local

ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(archs_with_dwz_low_mem)))
override_dh_dwz:
	dh_dwz -- --low-mem-die-limit $(dwz_low_mem)
endif
